$.webdb = {
    getdb : function(dbName, dbVersion, dbDisplayname, dbSize) {
        return window.openDatabase(dbName, dbVersion, dbDisplayname, dbSize);
    },
    create : function(dbName, dbVersion, dbDisplayname, dbSize) {
        var db = this.getdb(dbName, dbVersion, dbDisplayname, dbSize);
        db.transaction(function(tx) {
        	tx.executeSql('CREATE TABLE IF NOT EXISTS T_PROXYSET (id unique,server,port,isauth,username,password)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_FLAG (id)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_LOGIN_SIGN (sign,userName)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_EXIT_FLAG (id)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_LOGIN_NAME (id)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_LOGIN_TIMES (id)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_IS_EMECENTER (id)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_PATTERNLOCK (id,password,ispattern,patternVisible)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_USERINFO (id,user,areaCode,areaLevel)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_AREAINFO (id unique,areaid,area)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_WEATHERBASIC (id unique,isDay,weatherBackgroundImage,weatherLogo,aqi,city,co,fengli,fengxiang,high,low,majorPollutants,no2,o3,pm10,pm25,quality,shidu,so2,suggest,sunrise_1,sunset_1,updatetime,wendu,day_type,night_type,time)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_SEARCH_HISTORY (id INTEGER NOT NULL PRIMARY KEY,type TEXT,history TEXT,time INTEGER)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_FOLDERPAGE_STATUS (id,name,status)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_UPLOADLIST (id,type,name,localurl,url,flag)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_DOWNLOADLIST (id,type,name,url,flag)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS T_SERVERTYPE (id,type)');
        }, this.errorCB, function() {
            console.log('create success,dbName=' + dbName);
        });
        return db;
    },
    deleteAll : function(database, tableName) {
        var db = database;
        db.transaction(function(tx) {
            tx.executeSql('DELETE FROM ' + tableName);
        }, this.errorCB, function() {
            console.log('delete all records!');
        });
    },
    dropTable : function(database, tableName) {
        var db = database;
        db.transaction(function(tx) {
            tx.executeSql('DROP TABLE IF EXISTS ' + tableName);
        }, this.errorCB, function() {
            console.log('delete success,tableName=' + tableName);
        });
    },
    select : function(database, tableName, callbackResult) {
        var db = database;
        db.transaction(function(tx) {
            tx.executeSql('SELECT * FROM ' + tableName, [], function(tx, results) {
                callbackResult(results);
            }, this.errorCB);
        });
    },
    selectWithCondition : function(database, tableName, condition, callbackResult) {
        var db = database;
        db.transaction(function(tx) {
            tx.executeSql('SELECT * FROM ' + tableName + ' ' + condition, [], function(tx, results) {
                callbackResult(results);
            }, this.errorCB);
        });
    },
    executeSql : function(database, sql) {
        var db = database;
        db.transaction(function(tx) {
            tx.executeSql(sql);
        }, this.errorCB, function() {
            console.log(sql);
        });
    },
    executeSqlWithParam : function(database, sql, param, callbacFunction) {
        var db = database;
        db.transaction(function(tx) {
            tx.executeSql(sql, param);
            if(callbacFunction){
                callbacFunction();
            }
        }, this.errorCB, function() {
            console.log(sql);
        });
    },
    errorCB : function(err) {
        console.log("Error processing SQL: " + err.code);
    }
};
$.serverInfo = {
//	    server:"http://218.92.89.14:8080/gyyqxm",//笔记本wifi
//	    lawRegulationPage:"http://218.92.89.14:8080/gyyqxm/app/modules/lawRegulation/"
		
//		server:"http://172.19.153.1:8080/gyyqxm",//笔记本wifi
//		lawRegulationPage:"http://172.19.153.1:8080/gyyqxm/app/modules/lawRegulation/"

//		server:"http://192.168.0.107:8080/gyyqxm",//笔记本wifi
//		lawRegulationPage:"http://192.168.0.107:8080/gyyqxm/app/modules/lawRegulation/"

//		server:"http://192.168.136.59:8080/gyyqxm",//本地服务器
//    	lawRegulationPage:"http://192.168.136.59:8080/gyyqxm/app/modules/lawRegulation/"

//    	server:"http://localhost:8080/gyyqxm",//本机服务器
//    	lawRegulationPage:"http://localhost:8080/gyyqxm/app/modules/lawRegulation/"

//      server:"http://192.168.191.1:8088/gyyqxm",//qiudong
//      lawRegulationPage:"http://192.168.191.1:8088/gyyqxm/app/modules/lawRegulation/"
//
//      server:"http://218.92.89.14:8080/gyyqxm",//外网服务器
//      lawRegulationPage:"http://218.92.89.14:8080/gyyqxm/app/modules/lawRegulation/"
//		server:"http://218.92.104.98:7888/gyyqxm",//本机服务器
//    	lawRegulationPage:"http://218.92.104.98:7888/gyyqxm/app/modules/lawRegulation/"
		
		// server:"http://114.251.10.122/ecdomain"
        // server:"http://byjzx.natapp4.cc",
         server:"http://114.251.10.11:9999",
		// server:"http://127.0.0.1:9999",
//        server:"http://zwfw.mee.gov.cn/zwfwapp",
//		server:"http://localhost:8080/ecdomain"//,//本机服务器
//		server:"http://39.104.55.194/ecdomain"//阿里云服务器	
//		server:"http://172.20.10.6:8080/ecdomain"
//		server:"http:// 5.8.2.100:8080/ecdomain" 
};                                                                                   
// Html5取出当前设备信息
var browser={
    versions:function(){
        var u = navigator.userAgent, app = navigator.appVersion;
        return {
            //移动终端浏览器版本信息
            trident: u.indexOf('Trident') > -1,//IE内核
            presto: u.indexOf('Presto') > -1, //opera内核
            webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
            gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1, //火狐内核
            mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
            ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
            android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1, //android终端或uc浏览器
            iPhone: u.indexOf('iPhone') > -1 , //是否为iPhone或者QQHD浏览器
            iPad: u.indexOf('iPad') > -1, //是否iPad
            webApp: u.indexOf('Safari') == -1 //是否web应该程序，没有头部与底部
        };
     }(),
     language:(navigator.browserLanguage || navigator.language).toLowerCase()
};
var emeServices = angular.module('emeServices', []);
// factory方式
emeServices.factory('$serverInfo', ['$window', '$location', '$rootScope',
function($window, $location, $rootScope) {
    var serverInfo = {};
    // 内置服务注入
    return serverInfo;
}]);

