var appmain = angular.module('appmain', ['ionic', 'appmain.controllers','stServices']);

appmain.constant('$ionicLoadingConfig', {
  template: 'Default Loading Template...'
});

// database interface
var neusoftDb;

if(window.openDatabase){
    neusoftDb = $.webdb.create('neusoft','1.0','neusoftdb',1000000);
}else{
    console.log("no have openDatabase");
}

appmain.config(['$stateProvider',
            '$urlRouterProvider',
            '$ionicConfigProvider',
            'stServices.defaultOptions',
function($stateProvider, $urlRouterProvider,$ionicConfigProvider,$opt) {
    $ionicConfigProvider.views.maxCache(5);
    $ionicConfigProvider.navBar.alignTitle("center");
    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');
    $ionicConfigProvider.platform.android.form.checkbox("circle");
    $urlRouterProvider.otherwise('/');
    
    $opt.baseSiteUrl = $.serverInfo.server;
    $stateProvider.state('appmain', {
        url : '/',
        templateUrl : 'templates/indexLoginFirst/zhb_loginFirst.html',
        controller:'loginFirstController'
    });
    // 欢迎页
    $stateProvider.state('appmain.welcome', {
    	url : "/welcome",
        views : {
            'sidemenu' : {
                controller : 'welcomeController',
                templateUrl : 'templates/indexLoginFirst/welcome.html'
            }
        }
    });
}]);

appmain.run(function($ionicPlatform,$ionicPopup,$ionicHistory,$location,$window) {
    $ionicPlatform.ready(function() {
        if (window.StatusBar) {
            StatusBar.styleDefault();
        }
        // if the emeDb is null change cordova plugin to create db
        if(!neusoftDb){
            neusoftDb = $.webdb.create('neusoft','1.0','neusoftdb',1000000);
        }
        if (window.cordova && window.cordova.plugins.Keyboard) { 
        	console.log("++++++++++00");
  			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);  
  			console.log("++++++++++01");
  			cordova.plugins.Keyboard.disableScroll(true);
  			console.log("++++++++++02");
  			//延迟splash screnn 隐藏时间,不然会有短暂的白屏出现  
  			setTimeout(function () {  
  				console.log("++++++++++03");
  				navigator.splashscreen.hide();
  				console.log("++++++++++04");
  			}, 5000);  
  		}  
        $window.mzsl.exitApp($ionicPlatform, $ionicPopup, $ionicHistory, $location);
//        $window.mzsl.splashscreenHide();
    });

}); 
