var appmain = angular.module('appmain', ['ionic', 'appmain.controllers','stServices']);

appmain.constant('$ionicLoadingConfig', {
  template: 'Default Loading Template...'
});

// database interface
var neusoftDb;

if(window.openDatabase){
    neusoftDb = $.webdb.create('neusoft','1.0','neusoftdb',1000000);
//    neusoftDb = window.openDatabase('neusoft','1.0','neusoftdb',1000000); 
}else{
    console.log("no have openDatabase");
}

appmain.config(['$stateProvider',
            '$urlRouterProvider',
            '$ionicConfigProvider',
            'stServices.defaultOptions',
function($stateProvider, $urlRouterProvider,$ionicConfigProvider,$opt) {
    $ionicConfigProvider.views.maxCache(0);
    $ionicConfigProvider.navBar.alignTitle("center");
    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');
    $ionicConfigProvider.platform.android.form.checkbox("circle");
    $ionicConfigProvider.platform.ios.tabs.style('standard'); 
    $ionicConfigProvider.platform.ios.tabs.position('top');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('top');
    $urlRouterProvider.otherwise('/appmain/main');

    $opt.baseSiteUrl = $.serverInfo.server;
    //================================互联网+=================================================
    // 1.右侧菜单
    $stateProvider.state('appmain', {
        url : "/appmain",
        abstract : true,
        controller : 'menuController',
        templateUrl : 'templates/indexZHB/zhb_menu.html'
    });
    // 2.主页面
    $stateProvider.state('appmain.main', {
    	url : "/main",
    	views : {
    		'sidemenu' : {
    			controller : 'mainController',
    			templateUrl : 'templates/indexZHB/zhb_main.html'
    		}
    	}
    });
    // 3.基本信息页
    $stateProvider.state('appmain.myBaseInfo', {
    	url : "/myBaseInfo",
        views : {
            'sidemenu' : {
                controller : 'myBaseInfoController',
                templateUrl : 'templates/indexZHB/myBaseInfo.html'
            }
        }
    });
    // 4.我的办件页
    $stateProvider.state('appmain.myEvents', {
        url : "/myEvents",
        views : {
            'sidemenu' : {
                controller : 'myEventsController',
                templateUrl : 'templates/indexZHB/myEvents.html'
            }
        }
    });
    //5.办件详情
    $stateProvider.state('appmain.myEventDetail', {
        url : "/myEventDetail",
        views : {
            'sidemenu' : {
                controller : 'myEventDetailController',
                templateUrl : 'templates/indexZHB/myEventDetail.html'
            }
        }
    });
    //6.信息咨询页
    $stateProvider.state('appmain.information', {
        url : "/information",
        views : {
            'sidemenu' : {
                controller : 'informationController',
                templateUrl : 'templates/indexZHB/information.html'
            }
        }
    });
    //7.相关指南列表页
    $stateProvider.state('appmain.guideList', {
        url : "/guideList",
        views : {
            'sidemenu' : {
                controller : 'guideListController',
                templateUrl : 'templates/indexZHB/guideList.html'
            }
        }
    });
    //8.相关指南页
    $stateProvider.state('appmain.guideLine', {
        url : "/guideLine",
        views : {
            'sidemenu' : {
                controller : 'guideLineController',
                templateUrl : 'templates/indexZHB/guideLine.html'
            }
        }
    });
	//8.1 .常见问题解答详情页
	$stateProvider.state('appmain.guideModal', {
	    url : "/guideModal",
	    views : {
	        'sidemenu' : {
	            controller : 'guideModalController',
	            templateUrl : 'templates/indexZHB/guideModal.html'
	        }
	    }
	});
	
    //9.常见问题解答详情页
    $stateProvider.state('appmain.questionModal', {
        url : "/questionModal",
        views : {
            'sidemenu' : {
                controller : 'questionModalController',
                templateUrl : 'templates/indexZHB/questionModal.html'
            }
        }
    });
    //10.咨询投诉选项
    $stateProvider.state('appmain.selectComplaint', {
        url : "/selectComplaint",
        views : {
            'sidemenu' : {
                controller : 'selectComplaintController',
                templateUrl : 'templates/indexZHB/selectComplaint.html'
            }
        }
    });
    // 11.咨询投诉填报
    $stateProvider.state('appmain.complaintAdvice', {
        url : "/complaintAdvice",
        views : {
            'sidemenu' : {
                controller : 'complaintAdviceController',
                templateUrl : 'templates/indexZHB/complaintAdvice.html'
            }
        }
    });
    // 12.我的咨询页
    $stateProvider.state('appmain.myConsult', {
        url : "/myConsult",
        views : {
            'sidemenu' : {
                controller : 'myConsultController',
                templateUrl : 'templates/indexZHB/myConsult.html'
            }
        }
    });
    //13.咨询详情
    $stateProvider.state('appmain.myConsultDetail', {
        url : "/myConsultDetail",
        views : {
            'sidemenu' : {
                controller : 'myConsultDetailController',
                templateUrl : 'templates/indexZHB/myConsultDetail.html'
            }
        }
    });
    //14.我的评价
    // $stateProvider.state('appmain.myComment', {
    //     url : "/myComment",
    //     views : {
    //         'sidemenu' : {
    //             controller : 'myCommentController',
    //             templateUrl : 'templates/indexZHB/myComment.html'
    //         }
    //     }
    // });
    //15.我的评价详情
    // $stateProvider.state('appmain.myCommentDetail', {
    //     url : "/myCommentDetail",
    //     views : {
    //         'sidemenu' : {
    //             controller : 'myCommentDetailController',
    //             templateUrl : 'templates/indexZHB/myCommentDetail.html'
    //         }
    //     }
    // });
  //16.我的评价详情追评
    // $stateProvider.state('appmain.myCommentDetailZP', {
    //     url : "/myCommentDetailZP",
    //     views : {
    //         'sidemenu' : {
    //             controller : 'myCommentDetailZPController',
    //             templateUrl : 'templates/indexZHB/myCommentDetailZP.html'
    //         }
    //     }
    // });
	//17.我的咨询与投诉
	$stateProvider.state('appmain.zxtsHome', {
	    url : "/zxts/zxtsHome",
	    views : {
	        'sidemenu' : {
	            controller : 'zxtsHomeController',
	            templateUrl : 'templates/indexZHB/zxts/zxtsHome.html'
	        }
	    }
	});
	
	$stateProvider.state('appmain.zxInfo', {
	    url : "/zxts/zxInfo",
	    views : {
	        'sidemenu' : {
	            controller : 'zxInfoController',
	            templateUrl : 'templates/indexZHB/zxts/zxInfo.html'
	        }
	    }
	});
	$stateProvider.state('appmain.tsList', {
	    url : "/zxts/tsList",
	    views : {
	        'sidemenu' : {
	            controller : 'tsListController',
	            templateUrl : 'templates/indexZHB/zxts/tsList.html'
	        }
	    }
	});
	$stateProvider.state('appmain.tsInfo', {
	    url : "/zxts/tsInfo",
	    views : {
	        'sidemenu' : {
	            controller : 'tsInfoController',
	            templateUrl : 'templates/indexZHB/zxts/tsInfo.html'
	        }
	    }
	});
	
	$stateProvider.state('appmain.registUser', {
	    url : "/regist/registUser",
	    views : {
	        'sidemenu' : {
	            controller : 'registUserController',
	            templateUrl : 'templates/indexZHB/regist/registUser.html'
	        }
	    }
	});
	
	
	
  //================================互联网+end=================================================
//    // 密码修改
//    $stateProvider.state('appmain.passwordChange', {
//        url : "/passwordChange",
//        views : {
//            'sidemenu' : {
//                controller : 'passwordChangeController',
//                templateUrl : 'templates/indexZHB/mzsl_passwordChange.html'
//            }
//        }
//    });
//    
//    // 用户信息修改
//    $stateProvider.state('appmain.userInfo', {
//        url : "/userInfo",
//        views : {
//            'sidemenu' : {
//                controller : 'userInfoController',
//                templateUrl : 'templates/indexZHB/mzsl_userInfo.html'
//            }
//        }
//    });

//    // 关于平台
//    $stateProvider.state('appmain.aboutPlatform', {
//        url : "/aboutPlatform",
//        views : {
//            'sidemenu' : {
//                controller : 'aboutPlatformController',
//                templateUrl : 'templates/indexZHB/mzsl_aboutPlatform.html'
//            }
//        }
//    });

    // 功能介绍
    $stateProvider.state('appmain.features', {
        url : "/features",
        views : {
            'sidemenu' : {
                controller : 'featuresController',
                templateUrl : 'templates/indexZHB/aboutPlatform/features.html'
            }
        }
    });

}]);


appmain.run(function($ionicPlatform,$ionicPopup,$ionicHistory,$location,$window) {
    $ionicPlatform.ready(function() {
        if (window.StatusBar) {
            StatusBar.styleLightContent();
            StatusBar.backgroundColorByHexString("#1785d8");
        }
        // if the emeDb is null change cordova plugin to create db
        if(!neusoftDb){
            neusoftDb = $.webdb.create('neusoft','1.0','neusoftdb',1000000);
        }
//        if (window.cordova && window.cordova.plugins.Keyboard) {
//          console.log("++++++++++00");
//              cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
//              console.log("++++++++++01");
//              cordova.plugins.Keyboard.disableScroll(true);
//              console.log("++++++++++02");
//              //延迟splash screnn 隐藏时间,不然会有短暂的白屏出现
//              setTimeout(function () {
//                  console.log("++++++++++03");
//                  navigator.splashscreen.hide();
//                  console.log("++++++++++04");
//              }, 5000);
//          }
        $window.mzsl.exitApp($ionicPlatform, $ionicPopup, $ionicHistory, $location);
        $window.mzsl.splashscreenHide();
        var updateUrl = "http://zwfw.mee.gov.cn/netPlusService/getAppVersion";
        if(window.AppUpdate){
            window.AppUpdate.checkAppUpdate(function(d){
                console.log(d);
            }, function(e){
                console.log(e);
            }, updateUrl);
        }

    });
}); 
