/**
 *  stream-ui-core v0.1.0.rc2
 *  Stream UI的核心服务
*/

//stream-ui types

//类StPage
var StPage = function(id, currentPage, limit){
	this.id = id;
	if(currentPage){
		if(angular.isNumber(currentPage)){
			this.currentPage = currentPage;
		}else{
			try{
				this.currentPage = Number(currentPage);
			}catch(err){
				this.currentPage = 1;
			}
		}
	}else{
		this.currentPage = 1;
	}
	if(limit){
		if(angular.isNumber(currentPage)){
			this.limit = limit;
		}else{
			try{
				this.limit = Number(limit);
			}catch(err){
				this.limit = 10;
			}
		}
	}else{
		this.limit = 10;
	}
	this.totalRecords = 0;
	this.totalPages = 0;
	this.offset = 0;
};



// stServices
angular.module('stServices', []).constant('stServices.defaultOptions',
		{
			'httpHeader': {'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
			'baseSiteUrl': '',
			'contextDataUrl': 'action/framework/servicectx',
			'metadataUrl': 'action/framework/servicemeta',
			'businessDataUrl': 'action/framework/frontcontroller',
			'acceptFormat': {'format': 'json'}
		}
)

.value('stServices.serviceBeanMap', {})

.value('stServices.serviceCtx', {})

.value('stServices.initMetaFuc', function(dfOpt, sbMap, $http, $log, $q, $rootScope){
    var _headers = dfOpt.httpHeader;
    var _metadataUrl;
    var _businessDataUrl;
    if(dfOpt.baseSiteUrl === ''){
        _metadataUrl = dfOpt.metadataUrl;
        _businessDataUrl = dfOpt.businessDataUrl;
    }
    else{
        _metadataUrl = dfOpt.baseSiteUrl + '/' + dfOpt.metadataUrl;
        _businessDataUrl = dfOpt.baseSiteUrl + '/' + dfOpt.businessDataUrl;
    }
    var _acceptFormat = dfOpt.acceptFormat;

    var bindProxyBean = function(metadata){
        if(!metadata || !angular.isArray(metadata)){
            $log.error('元数据非法：' + angular.toJson(metadata));
            return;
        }
        sbMap.map = {};
        angular.forEach(metadata, function(beanObj){
            var proxyBean = {};
            proxyBean.name = beanObj.beanName;
            angular.forEach(beanObj.methods, function(methodObj){
                proxyBean[methodObj.methodAliasName === '' ? methodObj.methodName : methodObj.methodAliasName] =
                    function(){
                        var _paramValues = [];
                        angular.forEach(arguments, function(elem){
                            _paramValues.push(elem);
                        });
                        var paramNum = _paramValues.length;
                        var _pageManager = [];
                        if(paramNum > 0){
                            var lastParam = _paramValues[paramNum-1];
                            if(lastParam instanceof StPage){
                                _pageManager.push(_paramValues.pop());
                            }else if(angular.isArray(lastParam) && lastParam.length > 0){
                                var isPageInfo = true;
                                $.each(lastParam, function(i, lastElem){
                                    if(!(lastElem instanceof StPage)){
                                        isPageInfo = false;
                                        return false;
                                    }
                                });
                                if(isPageInfo){
                                    _pageManager = _paramValues.pop();
                                }
                            }
                            if(_paramValues.length !== methodObj.paramTypes.length){
                                $log.error('参数数量不匹配：' + angular.toJson(_paramValues));
                                return;
                            }
                        }else{
                            if(methodObj.paramTypes.length  !== 0){
                                $log.error('没有传递输入参数！');
                                return;
                            }
                        }
                        var _streamoneApplicationData = {
                            serviceName: beanObj.beanName,
                            serviceMethod: methodObj.methodName,
                            paramTypes: methodObj.paramTypes,
                            paramValues: _paramValues,
                            pageManager: _pageManager
                        };
                        var _paramData = "_streamoneApplicationData=" +
                            encodeURIComponent(encodeURIComponent(angular.toJson(_streamoneApplicationData)));
                        var promise = $http({headers: _headers, method: 'POST', url: _businessDataUrl, params: _acceptFormat, data: _paramData}).
                            then(function(response){
                                var data = response.data;
								if(data.returnCode === 0){   //操作成功
									return response;
								}else if(data.returnCode === -1){
                                    var errStr = data.returnMessage;
                                    $log.error(errStr);
                                    return $q.reject(errStr);
								}else if(data.returnCode === -2){   //未登录
									$rootScope.$broadcast("SYS_MSG_NOTLOGIN");
									var errStr = '业务操作失败：未登录';
									$log.error(errStr);
									return $q.reject(errStr);
								}else if(data.returnCode === -3){   //被踢出
									$rootScope.$broadcast("SYS_MSG_KICKOUT");
									var errStr = '业务操作失败：被踢出';
									$log.error(errStr);
									return $q.reject(errStr);
								}else if(data.returnCode === -4){   //没有操作权限
									$rootScope.$broadcast("SYS_MSG_NOPERMISSION");
									var errStr = '业务操作失败：没有操作权限';
									$log.error(errStr);
									return $q.reject(errStr);
								}else{
									return $q.reject();
								}
                            },
                            function() {
								$rootScope.$broadcast("SYS_MSG_NETWORKERR");
                                var errStr = '业务操作失败：网络通讯异常！';
                                $log.error(errStr);
                                return $q.reject(errStr);
                            });
                        promise.success = function(fn){
                            promise.then(function(response){
                                var data = response.data;
                                if(data.pageManager && angular.isArray(data.pageManager)){
                                    angular.forEach(data.pageManager, function(page, key){
                                        var stPage = new StPage(page.id, page.currentPage, page.limit);
                                        stPage.totalRecords = page.totalRecords;
                                        stPage.totalPages = page.totalPages;
                                        stPage.offset = page.offset;
                                        data.pageManager[key] = stPage;
                                    });
                                }else{
                                    data.pageManager = [];
                                }
                                fn(data.resultObj, data.pageManager);
                            });
                            return promise;
                        };
                        promise.error = function(fn){
                            promise.then(null, fn);
                            return promise;
                        };
                        return promise;
                    };
            });
            sbMap.map[proxyBean.name] = proxyBean;
        });
    };

    sbMap.map = $http({headers: _headers, method: 'GET', url: _metadataUrl, params: _acceptFormat}).
        then(function(response){
            var data = response.data;
            if(data.returnCode === -1){
				$rootScope.$broadcast('SYS_MSG_GETMETAERR');
                var errStr = '获取服务元数据操作失败：' + data.returnMessage;
                $log.error(errStr);
                return $q.reject(errStr);
            }
            sbMap._metadata = data.resultObj;
            bindProxyBean(data.resultObj);
            return sbMap.map;
        },function(){
            sbMap.metaErr = true;   //最近一次获取服务元数据操作失败
			$rootScope.$broadcast('SYS_MSG_NETWORKERR');
            var errStr = '获取服务元数据，网络通讯失败！';
            $log.error(errStr);
            return $q.reject(errStr);
        });
})

.value('stServices.initCtxFuc', function(dfOpt, sCtx, $http, $log, $q, $rootScope){
	var _headers = dfOpt.httpHeader;
	var _contextDataUrl;
	if (dfOpt.baseSiteUrl === '') {
		_contextDataUrl = dfOpt.contextDataUrl;
	}else {
		_contextDataUrl = dfOpt.baseSiteUrl + '/' + dfOpt.contextDataUrl;
	}
	var _acceptFormat = dfOpt.acceptFormat;

	sCtx.ctxData = $http({headers: _headers, method: 'GET', url: _contextDataUrl, params: _acceptFormat}).
		then(function(response){
			var data = response.data;
			if(data.returnCode === -1){
				$rootScope.$broadcast('SYS_MSG_GETCTXERR');
				var errStr = '获取服务上下文环境数据操作失败：' + data.returnMessage;
				$log.error(errStr);
				return $q.reject(errStr);
			}
			sCtx.ctxData = data.resultObj;
			return sCtx.ctxData;
		},function(){
			sCtx.Err = true;   //最近一次获取服务上下文环境数据操作失败
			$rootScope.$broadcast('SYS_MSG_NETWORKERR');
			var errStr = '获取服务上下文环境数据，网络通讯失败！';
			$log.error(errStr);
			return $q.reject(errStr);
		});
})

.run(['stServices.defaultOptions', 'stServices.serviceBeanMap', 'stServices.serviceCtx',
		'$http', '$log', '$q', '$rootScope', 'stServices.initMetaFuc', 'stServices.initCtxFuc',
    function(dfOpt, sbMap, sCtx, $http, $log, $q, $rootScope, initMetaFuc, initCtxFuc){
        //获取服务元数据并生成代理对象
//        initMetaFuc(dfOpt, sbMap, $http, $log, $q, $rootScope);
		//获取服务上下文环境数据
//		initCtxFuc(dfOpt, sCtx, $http, $log, $q);
	}
])

.provider('$stDS',
	function(){
		this.$get = ['stServices.defaultOptions', 'stServices.serviceBeanMap', 'stServices.serviceCtx', '$http', '$log', '$q', 'stServices.initMetaFuc', 'stServices.initCtxFuc',
            function(dfOpt, sbMap, sCtx, $http, $log, $q, initMetaFuc, initCtxFuc){
                return {
					getBean: function(beanName){
						if(sbMap.metaErr){
							sbMap.metaErr = false;
							initMetaFuc(dfOpt, sbMap, $http, $log, $q);
						}
						return $q.when(sbMap.map).then(function(value){return value[beanName];},
							function(reason){
								return $q.reject(reason);});
					},
					getCtx: function(){
						if(sCtx.Err){
							sCtx.Err = false;
//							initCtxFuc(dfOpt, sCtx, $http, $log, $q);
						}
						return $q.when(sCtx.ctxData).then(function(value){return value;},
							function(reason){return $q.reject(reason);});
					}
               };
		    }];
	}
)

.provider('$stRouteRv',
	function(){
        var debug=false;
		var moduleRootPath = 'app/modules';
		var _getMappedCtlName = function(templateUrl){
			return templateUrl.replace('.html', 'Ctl').replace('/', '.');
		};
		var _getMappedScriptUrl = function(templateUrl){
            var tail;
            if(debug){
                tail = 'Ctl.js';
            }else{
                tail = 'Ctl.min.js';
            }
			var scriptUrl = templateUrl.replace('.html', tail);
			scriptUrl = moduleRootPath + '/' + scriptUrl;
			return scriptUrl;
		};
        this.setDebug = function(val){
            debug = val;
        };
		this.setModuleRootPath = function(path){
			moduleRootPath = path;
		};
		this.getModuleRootPath = function(){
			return moduleRootPath;
		};
		this.getMappedCtlName = _getMappedCtlName;
		this.setMappedCtlNameFn = function(fn){
			_getMappedCtlName = fn;
		};
		this.getMappedScriptUrl = _getMappedScriptUrl;
		this.setMappedScriptUrlFn = function(fn){
			_getMappedScriptUrl = fn;
		};
		this.resolve = function(templateUrl){
			var routeDef = {};
			routeDef.templateUrl = moduleRootPath + '/' + templateUrl;
			routeDef.controller = _getMappedCtlName(templateUrl);
			routeDef.resolve = {
				load: ['$q', '$rootScope', function($q, $rootScope){
					var defer = $q.defer();
					$.ajax({
						url: _getMappedScriptUrl(templateUrl),
						dataType: "script",
						cache: true,
						dataFilter: function(data, type){
							data = '//@ sourceURL=' + this.url + '\r' + data;
                            return data;
						},
						success: function(){
							defer.resolve();
							$rootScope.$apply();
						},
						error: function(){
							defer.reject();
						}
					});
					return defer.promise;
				}]
			};
			return routeDef;
		};
		this.$get = function(){
			return this;
		};
	}
);



//stMock
angular.module('stMock', ['ngMockE2E', 'stServices'])

.value('stMock.serviceBeanMap', {})

.provider('$stDSMock', function(){
	this.$get = ['stMock.serviceBeanMap', 'stServices.defaultOptions', '$httpBackend', function(sbMap, serviceOpts, $httpBackend){
		var dsObj = {};
		dsObj._metadata = [];
		//返回Mock过的service元数据
		dsObj.metadata = function(){
			return {
				returnCode: 0,
				returnMessage: '',
				resultObj: this._metadata
				};
		};

		dsObj.contextData = function(){
			return {
				returnCode: 0,
				returnMessage: '',
				resultObj: {"webCtxPath": "/stf", "webUploadPath": "/stf/upload"}
			};
		};
		
		dsObj.bean = function(beanName){
			var beanObj = {};
			$.each(this._metadata, function(i, e){
				if(e.beanName === beanName){
					beanObj._beanMeta = e;
					return false;
				}
			});
			if(!beanObj._beanMeta){
				beanObj._beanMeta = {};
				beanObj._beanMeta.beanName = beanName;
				beanObj._beanMeta.methods = [];
				this._metadata.push(beanObj._beanMeta);
			}
			
			beanObj.method = function(methodString){
				var methodName;
				var paramTypes;
				var _idx = methodString.indexOf("(");
				if(_idx === -1){   //无参数
					methodName = methodString;
					paramTypes = [];
				}else{
					methodName = methodString.substring(0, _idx);
					var paramString = methodString.substring(_idx+1, methodString.length-1);
					paramTypes = paramString.split(",");
				}
				var methodObj = {};
				$.each(this._beanMeta.methods, function(i, e){
					if(e.methodName === methodName){
						methodObj._methodMeta = e;
						return false;
					}
				});
				if(!methodObj._methodMeta){
					methodObj._methodMeta = {};
					methodObj._methodMeta.methodName = methodName;
					methodObj._methodMeta.methodAliasName = '';
					methodObj._methodMeta.paramTypes = paramTypes;
					methodObj._methodMeta.returnType = '';
					this._beanMeta.methods.push(methodObj._methodMeta);
				}
				methodObj.data = function(data){
					sbMap[beanName+'.'+methodName] = data;
				};
				return methodObj;
			};
			return beanObj;
		};
		return {
			ds: dsObj,
			mock: function(){
				var _metadataUrl;
				var _contextDataUrl;
				var _businessDataUrl;
				if(serviceOpts.baseSiteUrl === ''){
					_metadataUrl = serviceOpts.metadataUrl;
					_contextDataUrl = serviceOpts.contextDataUrl;
					_businessDataUrl = serviceOpts.businessDataUrl;
				}else{
					_metadataUrl = serviceOpts.baseSiteUrl + '/' + serviceOpts.metadataUrl;
					_contextDataUrl = serviceOpts.baseSiteUrl + '/' + serviceOpts.contextDataUrl;
					_businessDataUrl = serviceOpts.baseSiteUrl + '/' + serviceOpts.businessDataUrl;
				}
				//http请求Mock响应
				$httpBackend.whenGET(new RegExp('^' + _metadataUrl.replace(/\//g, '\\/') + '\\?')).respond(this.ds.metadata());
				$httpBackend.whenGET(new RegExp('^' + _contextDataUrl.replace(/\//g, '\\/') + '\\?')).respond(this.ds.contextData());
				$httpBackend.whenGET(/.*/).passThrough();
				$httpBackend.whenPOST(new RegExp('^' + _businessDataUrl.replace(/\//g, '\\/') + '\\?')).respond(
						//Mock处理stf框架后台服务
						function(method, url, data){
							data = decodeURIComponent(decodeURIComponent(data));
							data = data.substring(('_streamoneApplicationData=').length);
							data = angular.fromJson(data);
							var serviceData = sbMap[data.serviceName + '.' + data.serviceMethod];
							var responseData;
							if(angular.isArray(data.pageManager) && data.pageManager.length > 0){   //翻页数据
								var pageInfo = data.pageManager[0];
								var totalRecords = serviceData.length;
								pageInfo.totalRecords = totalRecords;
								pageInfo.totalPages = Math.ceil(totalRecords / pageInfo.limit);
								pageInfo.currentPage = pageInfo.currentPage <= pageInfo.totalPages ?
										pageInfo.currentPage : pageInfo.totalPages;
								pageInfo.offset = (pageInfo.currentPage - 1) * pageInfo.limit;
								serviceData = serviceData.slice(pageInfo.offset, pageInfo.offset + pageInfo.limit);
								responseData = {
										returnCode: 0,
										returnMessage: '',
										resultObj: serviceData,
										pageManager: [pageInfo]
								};
							}else{    //非翻页数据
								responseData = {
										returnCode: 0,
										returnMessage: '',
										resultObj: serviceData
								};
							}
							return [200, responseData];
						}
				);
				$httpBackend.whenPOST(/.*/).passThrough();
			}
		};
	}];
});



//stAuth 权限服务,处理登录状态和权限
angular.module('stAuth', ['stServices'])

.constant('stAuth.defaultOptions', {
	loginUrl: '/login'
})

.provider('$stAuth',
	function(){
		this.resolve = ['$stDS', '$q', '$rootScope', '$location', '$log', 'stAuth.defaultOptions', function($stDS, $q, $rootScope, $location, $log, defaultOpts){
			var deferred = $q.defer();
			if($location.path() === defaultOpts.loginUrl){
				deferred.resolve();
			}else if($rootScope.isAuthenticated === undefined){
				$stDS.getBean('stfAuthService').then(
					function(bean){
						bean.isAuthenticated().success(function(data){
							if(data === true){
								$rootScope.isAuthenticated = true;
								deferred.resolve();
                                $rootScope.$broadcast('SYS_MSG_LOGIN');
							}else{
								$rootScope.isAuthenticated = false;
								deferred.reject();
								$rootScope.$broadcast('SYS_MSG_NOTLOGIN', $location.path());
							}
						}).error(function(){
							$log.error('检查登录信息失败！');
							deferred.reject();
						});
					},
					function(){
						$log.error('检查登录信息失败！');
						deferred.reject();
					}
				);
			}else if($rootScope.isAuthenticated){
				deferred.resolve();
			}else{
				deferred.reject();
				$rootScope.$broadcast('SYS_MSG_NOTLOGIN', $location.path());
			}
			return deferred.promise;
		}];

		this.$get = ['$stDS', '$q', '$rootScope',
			function($stDS, $q, $rootScope){
				return {
					//登录方法
					login: function(username, password){
						var deferred = $q.defer();
						$stDS.getBean('stfAuthService').then(function(bean){
							bean.login(username, password).success(function(res){
								if(res === 0){
									$rootScope.isAuthenticated = true;
								}
								deferred.resolve(res);
							}).error(function () {
								deferred.reject();
							});
						}, function(){
							deferred.reject();
						});
						return deferred.promise;
					},
					//注销方法
					logout: function(){
						var deferred = $q.defer();
						$stDS.getBean('stfAuthService').then(function(bean){
							bean.logout().success(function(){
								$rootScope.isAuthenticated = false;
								deferred.resolve();
							}).error(function(){
								deferred.reject();
							});
						}, function(){
							deferred.reject();
						});
						return deferred.promise;
					}
				};
			}];
	}
);