window.mzsl = {};

/**
 * mzsl exit app
 */
window.mzsl.exitApp = function($ionicPlatform, $ionicPopup, $ionicHistory, $location) {
    if(!$ionicPlatform){
        console.log("Please add the ionic js");
        return;
    }
    //主页面显示退出提示框
    $ionicPlatform.registerBackButtonAction(function(e) {
        e.preventDefault();
        function showConfirm() {
            var confirmPopup = $ionicPopup.confirm({
                title : '<strong>退出应用</strong>',
                template : '你确定要退出应用吗?',
                okText : '退出',
                cancelText : '取消'
            });
            confirmPopup.then(function(res) {
                if (res) {
                    ionic.Platform.exitApp();
                } else {
                    // Don't close
                }
            });
        }

        // Is there a page to go back to?
        if ($location.path() == '/') {
            showConfirm();
        } else if ($ionicHistory.backView()) {
            console.log('currentView:', $ionicHistory.backView().stateId);
            // Go back in history
            $ionicHistory.backView().go();
        } else {
            // This is the last page: Show confirmation popup
            showConfirm();
        }
        return false;
    }, 101);
}
/**
 * native alert
 *
 * @param {Object} title
 * @param {Object} message
 * @param {Object} buttonName
 * @param {function} callbackfunction
 */
window.mzsl.alert = function(title, message, buttonName, callbackfunction) {
    if(!navigator.notification){
        console.log("Please add the cordova.js or you not add the dialog plugin");
        return;
    }
    navigator.notification.alert(message, // message
    callbackfunction, // callback
    title, // title
    buttonName // buttonName
    );
}
/**
 * native confirm
 * 
 * @param {Object} title
 * @param {Object} message
 * @param {Object} buttonName
 * @param {Object} callbackfunction
 */
window.mzsl.confirm = function(title, message, buttonName, callbackfunction) {
    if(!navigator.notification){
        console.log("Please add the cordova.js or you not add the dialog plugin");
        return;
    }
    navigator.notification.confirm(message, // message
    callbackfunction, // callback to invoke with index of button pressed
    title, // title
    buttonName // buttonLabels
    );
}

/**
 * native prompt
 * 
 * @param {Object} title
 * @param {Object} message
 * @param {Object} buttonName
 * @param {Object} defaultText
 * @param {Object} callbackfunction
 */
window.mzsl.prompt = function(title, message, buttonName, defaultText, callbackfunction) {
    if(!navigator.notification){
        console.log("Please add the cordova.js or you not add the dialog plugin");
        return;
    }
    navigator.notification.prompt(message, // message
    callbackfunction, // callback to invoke
    title, // title
    buttonName, // buttonLabels
    defaultText // defaultText
    );
}

/**
 * native beep
 * 
 * @param {Object} count
 */
window.mzsl.beep = function(count){
    if(!navigator.notification){
        console.log("Please add the cordova.js or you not add the dialog plugin");
        return;
    }
    navigator.notification.beep(count);
}


/**
 * close the splash screen
 */
window.mzsl.splashscreenHide = function(){
    if(!navigator.splashscreen){
        console.log("Please add the cordova.js or you not add the splashscreen plugin");
        return;
    }
    navigator.splashscreen.hide();
}
